Index: django/contrib/databrowse/templates/databrowse/choice_detail.html
===================================================================
--- django/contrib/databrowse/templates/databrowse/choice_detail.html	(revision 5758)
+++ django/contrib/databrowse/templates/databrowse/choice_detail.html	(working copy)
@@ -10,7 +10,7 @@
 
 <ul class="objectlist">
 {% for object in object_list %}
-<li class="{% cycle odd,even %}"><a href="{{ object.url }}">{{ object }}</a></li>
+<li class="{% cycle odd,even %}"><a href="{{ object.url }}">{{ object|escape }}</a></li>
 {% endfor %}
 </ul>
 
Index: django/contrib/databrowse/templates/databrowse/calendar_month.html
===================================================================
--- django/contrib/databrowse/templates/databrowse/calendar_month.html	(revision 5758)
+++ django/contrib/databrowse/templates/databrowse/calendar_month.html	(working copy)
@@ -10,7 +10,7 @@
 
 <ul class="objectlist">
 {% for object in object_list %}
-<li class="{% cycle odd,even %}"><a href="{{ object.url }}">{{ object }}</a></li>
+<li class="{% cycle odd,even %}"><a href="{{ object.url }}">{{ object|escape }}</a></li>
 {% endfor %}
 </ul>
 
Index: django/contrib/databrowse/templates/databrowse/model_detail.html
===================================================================
--- django/contrib/databrowse/templates/databrowse/model_detail.html	(revision 5758)
+++ django/contrib/databrowse/templates/databrowse/model_detail.html	(working copy)
@@ -12,7 +12,7 @@
 
 <ul class="objectlist">
 {% for object in model.objects %}
-    <li class="{% cycle odd,even %}"><a href="{{ object.url }}">{{ object }}</a></li>
+    <li class="{% cycle odd,even %}"><a href="{{ object.url }}">{{ object|escape }}</a></li>
 {% endfor %}
 </ul>
 
Index: django/contrib/databrowse/templates/databrowse/choice_list.html
===================================================================
--- django/contrib/databrowse/templates/databrowse/choice_list.html	(revision 5758)
+++ django/contrib/databrowse/templates/databrowse/choice_list.html	(working copy)
@@ -10,7 +10,7 @@
 
 <ul class="objectlist">
 {% for choice in field.choices %}
-<li class="{% cycle odd,even %}"><a href="{{ choice.url }}">{{ choice.label }}</a></li>
+<li class="{% cycle odd,even %}"><a href="{{ choice.url }}">{{ choice.label|escape }}</a></li>
 {% endfor %}
 </ul>
 
Index: django/contrib/databrowse/templates/databrowse/calendar_day.html
===================================================================
--- django/contrib/databrowse/templates/databrowse/calendar_day.html	(revision 5758)
+++ django/contrib/databrowse/templates/databrowse/calendar_day.html	(working copy)
@@ -10,7 +10,7 @@
 
 <ul class="objectlist">
 {% for object in object_list %}
-<li class="{% cycle odd,even %}"><a href="{{ object.url }}">{{ object }}</a></li>
+<li class="{% cycle odd,even %}"><a href="{{ object.url }}">{{ object|escape }}</a></li>
 {% endfor %}
 </ul>
 
Index: django/contrib/databrowse/templates/databrowse/object_detail.html
===================================================================
--- django/contrib/databrowse/templates/databrowse/object_detail.html	(revision 5758)
+++ django/contrib/databrowse/templates/databrowse/object_detail.html	(working copy)
@@ -4,9 +4,9 @@
 
 {% block content %}
 
-<div id="breadcrumbs"><a href="{{ root_url }}">Home</a> / <a href="{{ object.model.url }}">{{ object.model.verbose_name_plural|capfirst }}</a> / {{ object }}</div>
+<div id="breadcrumbs"><a href="{{ root_url }}">Home</a> / <a href="{{ object.model.url }}">{{ object.model.verbose_name_plural|capfirst }}</a> / {{ object|escape }}</div>
 
-<h1>{{ object.model.verbose_name|capfirst }}: {{ object }}</h1>
+<h1>{{ object.model.verbose_name|capfirst }}: {{ object|escape }}</h1>
 
 <table class="objectinfo">
 {% for field in object.fields %}
@@ -29,7 +29,7 @@
   {% if related_object.object_list %}
   <ul class="objectlist">
     {% for object in related_object.object_list %}
-    <li class="{% cycle odd,even %}"><a href="{{ object.url }}">{{ object }}</a></li>
+    <li class="{% cycle odd,even %}"><a href="{{ object.url }}">{{ object|escape }}</a></li>
     {% endfor %}
   </ul>
   {% else %}