Index: django/views/generic/date_based.py
===================================================================
--- django/views/generic/date_based.py	(revision 5818)
+++ django/views/generic/date_based.py	(working copy)
@@ -286,7 +286,7 @@
 
 def object_detail(request, year, month, day, queryset, date_field,
         month_format='%b', day_format='%d', object_id=None, slug=None,
-        slug_field=None, template_name=None, template_name_field=None,
+        slug_field='slug', template_name=None, template_name_field=None,
         template_loader=loader, extra_context=None, context_processors=None,
         template_object_name='object', mimetype=None, allow_future=False):
     """
Index: django/views/generic/list_detail.py
===================================================================
--- django/views/generic/list_detail.py	(revision 5818)
+++ django/views/generic/list_detail.py	(working copy)
@@ -87,7 +87,7 @@
     return HttpResponse(t.render(c), mimetype=mimetype)
 
 def object_detail(request, queryset, object_id=None, slug=None,
-        slug_field=None, template_name=None, template_name_field=None,
+        slug_field='slug', template_name=None, template_name_field=None,
         template_loader=loader, extra_context=None,
         context_processors=None, template_object_name='object',
         mimetype=None):
Index: django/views/generic/create_update.py
===================================================================
--- django/views/generic/create_update.py	(revision 5818)
+++ django/views/generic/create_update.py	(working copy)
@@ -71,7 +71,7 @@
     return HttpResponse(t.render(c))
 
 def update_object(request, model, object_id=None, slug=None,
-        slug_field=None, template_name=None, template_loader=loader,
+        slug_field='slug', template_name=None, template_loader=loader,
         extra_context=None, post_save_redirect=None,
         login_required=False, follow=None, context_processors=None,
         template_object_name='object'):
@@ -146,7 +146,7 @@
     return response
 
 def delete_object(request, model, post_delete_redirect,
-        object_id=None, slug=None, slug_field=None, template_name=None,
+        object_id=None, slug=None, slug_field='slug', template_name=None,
         template_loader=loader, extra_context=None,
         login_required=False, context_processors=None, template_object_name='object'):
     """
Index: docs/generic_views.txt
===================================================================
--- docs/generic_views.txt	(revision 5818)
+++ docs/generic_views.txt	(working copy)
@@ -40,7 +40,7 @@
     }
 
     urlpatterns = patterns('django.views.generic.date_based',
-       (r'^(?P<year>\d{4})/(?P<month>[a-z]{3})/(?P<day>\w{1,2})/(?P<slug>[-\w]+)/$', 'object_detail', dict(info_dict, slug_field='slug')),
+       (r'^(?P<year>\d{4})/(?P<month>[a-z]{3})/(?P<day>\w{1,2})/(?P<slug>[-\w]+)/$', 'object_detail', info_dict),
        (r'^(?P<year>\d{4})/(?P<month>[a-z]{3})/(?P<day>\w{1,2})/$',               'archive_day',   info_dict),
        (r'^(?P<year>\d{4})/(?P<month>[a-z]{3})/$',                                'archive_month', info_dict),
        (r'^(?P<year>\d{4})/$',                                                    'archive_year',  info_dict),
@@ -603,7 +603,7 @@
 
       Otherwise, ``slug`` should be the slug of the given object, and
       ``slug_field`` should be the name of the slug field in the ``QuerySet``'s
-      model.
+      model. By default, ``slug_field`` is ``'slug'``.
 
 **Optional arguments:**
 
@@ -804,7 +804,7 @@
 
       Otherwise, ``slug`` should be the slug of the given object, and
       ``slug_field`` should be the name of the slug field in the ``QuerySet``'s
-      model.
+      model. By default, ``slug_field`` is ``'slug'``.
 
 **Optional arguments:**
 
@@ -948,7 +948,7 @@
 
       Otherwise, ``slug`` should be the slug of the given object, and
       ``slug_field`` should be the name of the slug field in the ``QuerySet``'s
-      model.
+      model. By default, ``slug_field`` is ``'slug'``.
 
 **Optional arguments:**
 
@@ -1033,7 +1033,7 @@
 
       Otherwise, ``slug`` should be the slug of the given object, and
       ``slug_field`` should be the name of the slug field in the ``QuerySet``'s
-      model.
+      model. By default, ``slug_field`` is ``'slug'``.
 
     * ``post_delete_redirect``: A URL to which the view will redirect after
       deleting the object.